% function posterior = findPosterior_LR(data,w)
%
% Apply LR weights 'w' (includes bias term in last column)
% with a logistic regression model to the 'data' to obtain
% class posteriors (2-class)
%
% Note the data should not contain an extra 'bias' term.
%
% data is dimension [numSamples numFeatures]
%
% posterior gives [p(label=0) p(label=1)] in two columns

function posterior = findPosterior_LR(data,w)

numRow = size(data,1);
biasD  = [data, ones(numRow,1)];    
repW = repmat(w,[numRow,1]);
z = sum(biasD.*repW,2);
posterior = logistic(z);


%% artifact of how was set up for DT
%%            p(~imm)      p(imm)
posterior = [1-posterior posterior];

if 0%any(posterior==1)
    warning('posterior==1 exactly?!, check weights');
    figure, bar(w);
    figure, bar(z);
    figure, bar(sort(logistic(z)));
    keyboard;
end


return




keyboard;
figure, plot(posterior(:,2),'+-');
figure, plot(w,'*-');
