function state = augment_position(points)
% state = augment_position(points)
% Augment a 2*T matrix of positions to create a 6*T vector of state.

% Author: David Ross, Jan. 2006
% %Id$

% approximate velocity and acceleration
velocity = diff(points,1,2);
acceleration = diff(points,2,2);

state = [points(1,:);
         velocity(1,[1:end end]);
         acceleration(1,[1:end end end]);
         points(2,:);
         velocity(2,[1:end end]);
         acceleration(2,[1:end end end])];

% smooth velocity acceleration
f = fspecial('gaussian',[1 5],1); % @TODO smoothing parameters?
% smooth everything
% state = filter2(f,state,'same');
% smooth velocity & acceleration only
state([2 3 5 6],:) = filter2(f, state([2 3 5 6],:), 'same');
%figure; plot(state(1,:),state(4,:));
%figure; plot(state(2,:),state(5,:));
%figure; plot(state(3,:),state(6,:));
