function [mu,sigma] = canonical_to_moment(nu,prec)
% [mu,sigma] = canonical_to_moment(nu,prec)    
%
% Convert the canonical parameters of a Gaussian (precision and
% scaled-mean) to it's moment parameters (covariance and mean).

% Author: David Ross, July 2006
% $Id: canonical_to_moment.m,v 1.1 2006/07/21 20:16:28 dross Exp $

error(nargchk(2,2,nargin));

if size(nu,1) ~= size(prec,1) || size(nu,2) ~= size(prec,3)
    error('sizes of nu and prec do not match');
end

mu = zeros(size(nu));
sigma = zeros(size(prec));

for nn = 1:size(nu,2)
    sigma(:,:,nn) = inv(prec(:,:,nn));
    mu(:,nn) = sigma(:,:,nn)*nu(:,nn);
end
