%% cdf_demo.m
%% Show the results of tracking, as a movie.
%%
%% Author: David Ross, Jan 2006.
%% $Id: cdf_demo.m,v 1.4 2007/07/13 19:08:10 dross Exp $

FIRST_FRAME = 1;
STEP = 1;
LAST_FRAME = Inf;

% should we write out each frame as a png image to
% the dump/ directory?
write_images = false;

% load nu if necessary?
nu = cat(3,Y{nn}.nu);
[D,K,T] = size(nu);

% UNCOMMENT THE CORRESPONDING DATA PATH
data_path = 'simon/simon/';
% data_path = 'roll_bounce/mov024/'; % roll only
% data_path = 'roll_bounce/mov027/'; % bounce only
% data_path = 'roll_bounce/mov029/'; % roll+bounce
% % % data_path = '/u/dross/datasets/basketball/simon/';
% % % data_path = '/u/dross/datasets/basketball/mov024/'; % roll only
% % % data_path = '/u/dross/datasets/basketball/mov027/'; % bounce only
% % % data_path = '/u/dross/datasets/basketball/mov029/'; % roll+bounce
if data_path(end) ~= filesep
    data_path(end+1) = filesep;
end
disp(['Using images from ' data_path '.  If this is incorrect, ' ...
      'please change the data_path variable.']);


% which version of inference do we want to use?
pV_demo = pV_imf; mu_demo = mu_imf; sigma_demo = sigma_imf;


figure('position',[0 0 360 240]);
set(gcf,'DoubleBuffer','on');
axes('position',[0 0 1 1]);
colormap gray;

for tt = FIRST_FRAME:STEP:min(T,LAST_FRAME)
    filename = sprintf('%s%04d.png',data_path, tt);
    im = imread(filename);
    xx = nu(1,:,tt);
    yy = nu(4,:,tt);

    imagesc(im, [0 255]);
    text(10,10,num2str(tt),'Color','w','FontSize',18);
    axis equal tight off;
    hold on;
    good = find(pV_demo(:,tt)>0.5);
    bad = setdiff(1:K,good);
    plot(xx(bad),yy(bad),'o', ...
        'MarkerEdgeColor','r',...        
        'MarkerFaceColor','r',...
        'MarkerSize', 8);
    plot(xx(good),yy(good),'s', ...
        'MarkerEdgeColor','y',...
        'MarkerFaceColor','y', ...
        'MarkerSize', 10);

    %     text(nu(1,1,tt),nu(4,1,tt),'T');
    %     text(nu(1,2,tt),nu(4,2,tt),'M');
    %     text(nu(1,3,tt),nu(4,3,tt),'M');
    %     text(nu(1,4,tt),nu(4,4,tt),'M');
    %     text(nu(1,5,tt),nu(4,5,tt),'M');
    %     text(nu(1,6,tt),nu(4,6,tt),'M');
    %     text(nu(1,7,tt),nu(4,7,tt),'B');
    %     text(nu(1,8,tt),nu(4,8,tt),'P');
    
    start = max(1,tt-10);
    %plot(X{1}(1,start:tt), X{1}(4,start:tt), 'ko--');
    plot_mu_sigma(mu_demo(:,start:tt), sigma_demo(:,:,start:tt));
    %plot(mu_demo(1,tt),mu_demo(4,tt),'.k');
    hold off;
    
    drawnow;
    if write_images
        imwrite(frame2im(getframe(gcf)), sprintf('dump/frame%04d.png',tt));
    end
    %pause;
end
