function d = compare_basis(x,basis)
% d = compare_basis(x,basis)
% x is image, b is a 3-dimensional basis
% images in basis should be orthogonal

x = double(x);
basis = double(basis);

[H,W,K] = size(basis);

x_sq = conv2(x.^2, ones(H,W), 'same');

xb = zeros(size(x_sq));
for kk = 1:K
    b_flip = flipud(fliplr(basis(:,:,kk)));
    xb = xb + conv2(x,b_flip,'same').^2;
end

d = x_sq - xb;
