function d = compare_basis(x,basis,mean)
% d = compare_basis(x,basis)
% x is image, b is a 3-dimensional basis
% images in basis should be orthogonal

x = double(x);
basis = double(basis);
mean = double(mean);

[H,W,K] = size(basis);

x_sq = conv2(x.^2, ones(H,W), 'same');

xb = zeros(size(x_sq));
for kk = 1:K
    b_flip = flipud(fliplr(basis(:,:,kk)));
    xb = xb + conv2(x,b_flip,'same').^2;
end

d = x_sq - xb;

% new part!

d = d + sum(sum(mean.^2));

b2 = reshape(basis,[H*W K]);
d = d - sum((b2'*mean(:)).^2);


filter = reshape((b2 * b2' - eye(H*W))*mean(:), [H W]);
filter = flipud(fliplr(filter));
d = d + 2*conv2(x, filter,'same');