function [A,aT,TaT] = compute_A_aT_TaT(at,u)
% [A,aT,TaT] = compute_A_aT_TaT(at,u)
% Compute A, aT, and TaT given a particular setting 'u' of the 
% uniGauss switches, and the result 'at' of init_A_aT_TaT.
%
% Calling init_A_aT_TaT to set things up and then compute_A_aT_TaT
% each time you have a new setting of the u's is a great deal
% faster than calling get_A_aT_TaT(alpha, Trans, u).

% Author: David Ross, Oct. 2005
% $Id: compute_A_aT_TaT.m,v 1.1.1.1 2006/06/01 15:32:21 dross Exp $

u = double(u);
A = combine(at.A,u);
aT = combine(at.aT,u);
TaT = combine(at.TaT,u);