function [EF,EG,ER,ES] = feature_expect_given_XUV(X,Y,U,V)
% [EF,EG,ER,ES] = feature_expect_given_XUV(X,Y,U,V)

% Author: David Ross, Nov. 2005
% $Id: feature_expect_given_XUV.m,v 1.2 2006/10/04 22:39:26 dross Exp $

%-----------------------------------------------------------
% Check the input
%-----------------------------------------------------------
error(nargchk(4,4,nargin));


%-----------------------------------------------------------
% Initialization
%-----------------------------------------------------------

[Trans,dd] = T_matrices;

% new version of Y
rr = [Y(1:end-1).rr];
ss = [Y.ss];
nu = cat(3,Y.nu);
nu = permute(nu, [1 3 2]);

D = size(X,1);
J = size(Trans,3);
K = size(nu,3);
T = size(X,2);


%-----------------------------------------------------------
% Do it.
%-----------------------------------------------------------

EF = zeros(D,D,J);
EG = zeros(D,D,K);
%ER = zeros(L,J);
%ES = zeros(M,K);

% Compute E_{U|X,Y} [F_j]
o = ones(1,T-1);
for jj = 1:J
    f_current = X(:,2:end) - Trans(:,:,jj)*X(:,1:end-1) - dd(:,jj)*o;
    EF(:,:,jj) = EF(:,:,jj) -0.5 * f_current*diag(U(jj,:))*f_current';
end

% Compute E_{U|X,Y} [G_k]
for kk = 1:K
    g_current = X - nu(:,:,kk);
    EG(:,:,kk) = EG(:,:,kk) -0.5 * g_current*diag(V(kk,:))*g_current';
end

% Compute E_{U|X,Y} [R]
if nargout >= 3
    ER = rr * U';
end

% Compute E_{U|X,Y} [S]
if nargout >= 4
    ES = ss * V';
end
