function [x] = gaussrnd(mu,covar,n)
% [x] = gaussrnd(mu,covar,n)
% Sample from a multivariate Gaussian.  
% Exactly the same as mvnrnd, except that it treats data as column
% vectors, and doesn't consume a stats toolbox license.

% Author: David Ross
% $Id: gaussrnd.m,v 1.1.1.1 2006/06/01 15:32:21 dross Exp $

if nargin < 3
    n = 1;
end

d = size(mu,1);
x = chol(covar)'*randn(d,n) + mu*ones(1,n);
