function [mu,prec] = gpp(varargin)
% [mu,prec] = gpp(mu1,prec1,mu2,prec2,...)
% Computes the mean and precision of the product of Gaussians
% with the specified means and precisions

% Author: David Ross, Aug. 2005
% $Id: gpp.m,v 1.1.1.1 2006/06/01 15:32:21 dross Exp $

mu = zeros(size(varargin{1}));
prec = zeros(size(varargin{2}));
for ii = 1:2:nargin
    this_prec = varargin{ii+1};
    prec = prec + this_prec;
    mu = mu + this_prec * varargin{ii};
end

% mu = prec \ mu; %@TODO which one?
mu = pinv(prec) * mu;
