function [result] = init_A_aT_TaT(alpha,Trans)
% alpha_trans = init_A_aT_TaT(alpha,Trans)
% 
% Does the multiplication part of computing A, aT, and TaT.  This
% calculation is the same for all values of u.  To do the weighted 
% summation part for a particular u, call compute_A_aT_TaT.
%
% Return value:
%   alpha_trans = a struct of three 3d matrices, A, aT, and TaT.
%
% Calling init_A_aT_TaT to set things up and then compute_A_aT_TaT
% each time you have a new setting of the u's is a great deal
% faster than calling get_A_aT_TaT(alpha, Trans, u).

% Author: David Ross, Oct. 2005
% $Id: init_A_aT_TaT.m,v 1.1.1.1 2006/06/01 15:32:22 dross Exp $

result.A = alpha;
result.aT = mult3(alpha,Trans);
result.TaT = mult3(permute(Trans,[2 1 3]),result.aT);
