function window = resample_window_std(image,T,sample_size)
% window = resample_window_std(image,T,sample_size)
%    Samples the window from image with corners T*(1,1), T*(-1,1),
%    T*(1,-1), and T*(-1,-1).  The resulting window will have a
%    resolution indicated by sample_size = [height, width];
%    

% Author: David Ross, Oct. 28, 2003.
% $Id: resample_window_std.m,v 1.2 2006/09/14 15:44:08 dross Exp $


error(nargchk(3,3,nargin));

width = sample_size(2);
height = sample_size(1);

% samples = [kron(linspace(-width/2,width/2,width), ones(1,height));
%     kron(ones(1,width), linspace(-height/2,height/2,height));
%     ones(1,width*height)];

samples = [kron(linspace(-1,1,width), ones(1,height));
    kron(ones(1,width), linspace(-1,1,height));
    ones(1,width*height)];

samples = T * samples;
window = resample(double(image), samples(1,:), samples(2,:));
window = reshape(window,[height width]);

