% run_behind_bin.m
% Test on the behind the bin (mov028) sequence.  To run this you must 
% first train on the rolling & bouncing sequences, using run_roll_bounce.m.
%
% This script requires the data to be in the sub-directory './mov028'
%
% One way to avoid unnecessarily re-running run_roll_bounce.m is to simply 
% load the result.mat file that it produces, and then run this script.

% David Ross, Sept. 2006
% $Id: run_behind_bin.m,v 1.3 2007/07/13 19:08:11 dross Exp $

if ~exist('alpha','var')
    error('you must load a set of parameters (alpha,beta,gamma,eta) first');
end

if exist('./result1.mat','file')
    error('result1.mat exists, and this function would overwrite it');
end

data_paths = {'./mov028'};
%data_paths = {'/u/dross/datasets/basketball/mov028'};

load models.mat;
X = load_points(data_paths{:});
Y = compute_features(models, data_paths{:});
save XY_mov028.mat X Y;

cdf_test(X,Y,alpha,beta,gamma,eta);
