#include "mex.h"
#include <math.h>
#include <stdlib.h>

#if 0
void softmax(double *x, int length) {
   int i;
   double offset, sum;

   offset = x[0];
   for(i=1; i < length; i++) {
      if (x[i] > offset) {
	 offset = x[i];
      }
   }

   offset -= log(DBL_MAX)/2;

   sum = 0.0;
   for(i=0; i < length; i++) {
      x[i] = exp(x[i] - offset);
      sum += x[i];
   }
   
   for(i=0; i < length; i++) {
      x[i] /= sum;
   }
}
#endif

void softmax(const double *x, int length, double *result) {
   int i;
   double offset, sum;

   offset = x[0];
   for(i=1; i < length; i++) {
      if (x[i] > offset) {
	 offset = x[i];
      }
   }

   offset -= log(DBL_MAX)/2;

   sum = 0.0;
   for(i=0; i < length; i++) {
      result[i] = exp(x[i] - offset);
      sum += result[i];
   }
   
   for(i=0; i < length; i++) {
      result[i] /= sum;
   }
}


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {
   double *x, *result;
   int rows, cols, i;

   /* check for the proper number of arguments */
   if (nrhs != 1) {
      mexErrMsgTxt("wrong number of input arguments");
   }
   if (nlhs != 1) {
      mexErrMsgTxt("wrong number of output arguments");
   }
   
   x = mxGetPr(prhs[0]);
   rows =mxGetM(prhs[0]);
   cols = mxGetN(prhs[0]);

   /* create the result */
   plhs[0] = mxCreateDoubleMatrix(rows, cols, mxREAL);
   result = mxGetPr(plhs[0]);
   
   for(i=0; i < cols; i++) {
      softmax(x+(i*rows), rows, result+(i*rows));
   }
   
   mxSetDimensions(plhs[0], mxGetDimensions(prhs[0]),
      mxGetNumberOfDimensions(prhs[0]));
}
