% test2_prob_X_given_UVY.m
%
% Compare two versions of prob_X_given_UVY to make sure they give
% similar results.  Right now it compares the canonical with the moment
% version.

% Author: David Ross, July 2006.
% $Id: test2_prob_X_given_UVY.m,v 1.1 2006/07/21 20:16:28 dross Exp $

clear;

T = 1000;
K = 1;

[Trans,dd] = T_matrices;
D = size(Trans,1);
J = size(Trans,3);

alpha = 3*rand(D,D,J);
beta = 3*rand(D,D,K);

alpha = diag_all(diag_all(alpha));
beta = diag_all(diag_all(beta));

Y(1).nu = [50,2,0.5,100,3,0.2]'*ones(1,K) + randn(6,K);
for tt = 2:T
    Y(tt).nu =  Trans(:,:,1)*Y(tt-1).nu + dd(:,1)*ones(1,K) + randn(6,K)/10;
end

U = softmax(exp(2*rand(J,T-1)));
V = sigmoid(exp(2*rand(K,T)));

[mu,sigma] = prob_X_given_UVY(Y,U,V,alpha,beta,'filter-only');
%[mu1,sigma1] =prob_X_given_UVY(Y,U,V,alpha,beta,'filter-only');
[nu,prec] = prob_X_given_UVY(Y,U,V,alpha,beta,'filter-only','precision');
[mu1,sigma1] = canonical_to_moment(nu,prec);


fo_mu_diff = sse(mu-mu1)
fo_sigma_diff = sse(sigma-sigma1)
fo_err = sum(abs(mu-mu1),1);

[mu,sigma,mu_pair,sigma_pair] = prob_X_given_UVY(Y,U,V,alpha,beta);
%[mu1,sigma1,mu_pair1,sigma_pair1] = prob_X_given_UVY(Y,U,V,alpha,beta);
[nu,prec,nu_pair,prec_pair] = prob_X_given_UVY(Y,U,V,alpha,beta,'precision');
[mu1,sigma1] = canonical_to_moment(nu,prec);
[mu_pair1,sigma_pair1] = canonical_to_moment(nu_pair,prec_pair);

mu_diff = sse(mu-mu1)
mu_pair_diff = sse(mu_pair-mu_pair1)
sigma_diff = sse(sigma-sigma1)
sigma_pair_diff = sse(sigma_pair-sigma_pair1)

err = sum(abs(mu-mu1),1);
plot(fo_err); hold on;
plot(err,'r'); hold off;
